const char tcl_new[] = "\
\n\
\n\
#new.tcl Copyright (c) 1995 University College London\n\
#see ui_fns.c for information on usage and redistribution of this file\n\
#and for a DISCLAIMER OF ALL WARRANTIES.\n\
\n\
proc new {aid} {\n\
    global ifstyle ldata\n\
    if {[string compare $aid \"new\"]!=0} {\n\
	#we need a working variable while we think about editing sessions,\n\
	#in case we don't commit the changes.\n\
	set ldata($aid,tmpmulticast) $ldata($aid,multicast)\n\
    }\n\
    if {$ifstyle(create)==\"norm\"} {\n\
	norm_new $aid\n\
    } else {\n\
	tech_new $aid\n\
    }\n\
}\n\
\n\
####\n\
#new creates a window to allow a new session to be defined\n\
####\n\
proc norm_new {aid} {\n\
    global send durationix sd_menu scope zone\n\
    global monthix dayix dayofmonth hrix ttl timeofday\n\
    global video_attr audio_attr whiteboard_attr\n\
    global ldata startdayofweek medialist media_fmt media_proto\n\
    global security\n\
    global yourphone\n\
    global youremail\n\
    global yourname\n\
    global new_createtime\n\
    if {[string length $yourphone]==0} {\n\
	enter_phone_details\n\
	return\n\
    }\n\
\n\
    catch {destroy .new}\n\
    toplevel .new\n\
    posn_win .new\n\
    if {[string compare $aid \"new\"]!=0} {\n\
	wm title .new \"Sdr: [tt \"Edit Session\"]\"\n\
	foreach i $medialist {\n\
            set send($i) 0\n\
        }\n\
  	set new_createtime $ldata($aid,createtime)\n\
    } else {\n\
	wm title .new \"Sdr: [tt \"Create New Session\"]\"\n\
	foreach i $medialist {\n\
	    set send($i) 0\n\
	}\n\
	set send(audio) 1\n\
	set new_createtime [unix_to_ntp [gettimeofday]]\n\
    }\n\
\n\
\n\
    new_mk_session_name .new $aid\n\
    new_mk_session_desc .new $aid\n\
    new_mk_session_url .new $aid\n\
\n\
    frame .new.type -relief groove -borderwidth 2\n\
    pack .new.type -side top -fill x -pady 2 -ipady 2\n\
    new_mk_session_type .new.type left $aid\n\
\n\
    if {[string compare $aid \"new\"]!=0} {\n\
	set sd_addr $ldata($aid,sd_addr)\n\
	set ttl $ldata($aid,ttl)\n\
	set scope ttl\n\
	set zone(cur_zone) $zone(ttl_scope)\n\
	for {set i 0} {$i<$zone(no_of_zones)} {incr i} {\n\
#	    puts \"$zone(sd_addr,$i)==$sd_addr)&&($zone(ttl,$i)==$ttl)\"\n\
	    if {($zone(sd_addr,$i)==$sd_addr)&&($zone(ttl,$i)==$ttl)} {\n\
#		puts \"setting zone(cur_zone) $i\"\n\
		set scope admin\n\
		set zone(cur_zone) $i\n\
	    }\n\
	}\n\
    } else {\n\
	set scope admin\n\
	set zone(cur_zone) 0\n\
	set ttl $zone(ttl,$zone(cur_zone))\n\
    }\n\
\n\
\n\
    frame .new.f3\n\
    pack .new.f3 -side top -pady 5 -fill x -expand true\n\
\n\
    catch {\n\
	new_mk_session_security .new.f3.l $aid\n\
    }\n\
\n\
    frame .new.f3.m -width 1 -height 1\n\
    pack .new.f3.m -side left -fill y -padx 3\n\
\n\
    #padding frame\n\
    pack [frame .new.f3.m2 -width 1 -height 1] -side left -fill y -padx 3\n\
\n\
    new_mk_session_admin .new.f3.admin $aid $scope\n\
    \n\
\n\
    #padding frame\n\
    pack [frame .new.f3.m3 -width 1 -height 1] -side left -fill y -padx 3\n\
\n\
    set show_details 0\n\
    new_mk_session_media .new.f3.media $aid $scope $show_details\n\
\n\
    frame .new.f2\n\
    frame .new.f2.act -relief groove -borderwidth 2\n\
    pack .new.f2.act -side left -fill both -expand true\n\
    pack .new.f2 -side top -pady 5 -fill x -expand true\n\
    pack [frame .new.f2.act.l] -side top -anchor w\n\
    label .new.f2.act.l.icon -bitmap clock\n\
    pack .new.f2.act.l.icon -side left\n\
    label .new.f2.act.l.l -text \"Session will take place ...\" \n\
    tixAddBalloon .new.f2.act.l.l Label [tt \"When and how often is the session going to be on\"]\n\
    pack .new.f2.act.l.l -side left\n\
\n\
    global rpt_times\n\
    global has_times\n\
    global needs_lifetime\n\
    global rpt_min_values \n\
    global rpt_menu_value\n\
    global duration_max\n\
\n\
    set rpt_times {{---} {Once} {Daily} {Weekly} {Every Two Weeks}\\\n\
     {Monthly by Date} {Monday thru Friday}}\n\
\n\
    #whether or not the times box should be active \n\
    set has_times {0 1 1 1 1 1 1}\n\
\n\
    set menu_disabled {0 0 0 0 0 1 1}\n\
\n\
    #whether or not there is a repeat time\n\
    set needs_lifetime {0 0 1 1 1 1 1}\n\
\n\
    #what the default minimum repeat time should be\n\
    set rpt_min_values {0 0 2880 20160 40320 40320 20160}\n\
\n\
    #what the max duration should be for each repeat interval\n\
    set duration_max {0 4838400 43200 518400 1036800 0 604800}\n\
\n\
    if {[string compare $aid \"new\"]!=0} {\n\
	for {set box 1} {$box <= $ldata($aid,no_of_times)} { incr box} {\n\
	    set rpt_menu_value($box) 1\n\
	    new_mk_session_time_box .new.f2.act.f$box $box $ldata($aid,no_of_times) $rpt_times $menu_disabled\n\
	}\n\
    } else {\n\
	set rpt_menu_value(1) 1\n\
	new_mk_session_time_box .new.f2.act.f1 1 1 $rpt_times $menu_disabled\n\
    }\n\
\n\
    label .new.f2.act.expl2 -text [tt \"Length of this series of sessions\"] \\\n\
	-font [resource infoFont]\n\
    pack .new.f2.act.expl2 -side top -anchor w\n\
    pack [frame .new.f2.act.fd] -side top -anchor w\n\
    pack [label .new.f2.act.fd.l -text [tt \"Repeat for:\"]] -side left -anchor w\n\
    duration_widget .new.f2.act.fd.duration 3600\n\
    if {[string compare $aid \"new\"]!=0} {\n\
	configure_duration_box .new.f2.act.fd $ldata($aid,no_of_times)\n\
    } else {\n\
	configure_duration_box .new.f2.act.fd 1\n\
    }\n\
    if {[string compare $aid \"new\"]!=0} {\n\
	set rpts 0\n\
	set maxdiff 0\n\
	for {set t 0} {$t < $ldata($aid,no_of_times)} {incr t} {\n\
	    if {$ldata($aid,time$t,no_of_rpts)==0} {\n\
		.new.f2.act.fb[expr $t+1].day.workaround configure \\\n\
		    -time $ldata($aid,starttime,$t)		\n\
		.new.f2.act.fb[expr $t+1].time.workaround configure \\\n\
		    -time $ldata($aid,starttime,$t)\n\
		.new.f2.act.fb[expr $t+1].duration.workaround configure -time \\\n\
		    [expr $ldata($aid,endtime,$t) - $ldata($aid,starttime,$t)]\n\
		set rpt_menu_value([expr $t+1]) 1\n\
		configure_rpt_menu [expr $t+1] .new.f2.act.fb[expr $t+1]\n\
	    } else {\n\
		set rpts 1\n\
		for {set r 0} {$r < $ldata($aid,time$t,no_of_rpts)} {incr r} {\n\
		    if {$r>0} {puts \"too complicated - tragic!\"}\n\
		    if {$ldata($aid,time$t,offset$r)!=\"0\"} {\n\
			puts \"too many offsets! - tragic!\"\n\
		    }\n\
		    set start $ldata($aid,starttime,$t)\n\
		    set end $ldata($aid,endtime,$t)\n\
		    set dur $ldata($aid,time$t,duration$r)\n\
		    set ofs $ldata($aid,time$t,offset$r)\n\
		    if {[expr ($end-$start)-$dur]> $maxdiff } {\n\
			     set maxdiff [expr ($end-$start)-$dur]\n\
		    }\n\
		    .new.f2.act.fb[expr $t+1].day.workaround configure -time $start\n\
		    .new.f2.act.fb[expr $t+1].time.workaround configure -time $start\n\
		    .new.f2.act.fb[expr $t+1].duration.workaround configure -time $dur\n\
		    case $ldata($aid,time$t,interval$r) in {\n\
			86400 {set rpt_menu_value([expr $t+1]) 2}\n\
			604800 {\n\
			    if {$ofs==\"0\"} {\n\
				set rpt_menu_value([expr $t+1]) 3\n\
			    } elseif {$ofs==\"0 86400 172800 259200 345600\"} {\n\
				set rpt_menu_value([expr $t+1]) 6\n\
			    } else {\n\
				puts \"help - can't handle this weekly offset\"\n\
			    }\n\
			}\n\
			1209600 {set rpt_menu_value([expr $t+1]) 4}\n\
		    }\n\
		    configure_rpt_menu [expr $t+1] .new.f2.act.fb[expr $t+1]\n\
		}\n\
	    }\n\
	}\n\
	if {$rpts==1} {\n\
	    .new.f2.act.fd.duration.workaround configure -time $maxdiff\n\
	    .new.f2.act.fd.duration.workaround configure -state normal\n\
	}\n\
    }\n\
    new_mk_session_contact .new.you $aid\n\
\n\
    new_mk_session_buttons .new.f4 $aid\n\
    move_onscreen .new\n\
    log \"displaying normal session creation interface at [getreadabletime]\"\n\
}\n\
\n\
####\n\
#new creates a window to allow a new session to be defined\n\
####\n\
set sizes(.new.x) 473\n\
set sizes(.new.y) 814\n\
proc tech_new {aid} {\n\
    global send durationix sd_menu scope zone\n\
    global monthix dayix dayofmonth hrix ttl timeofday\n\
    global video_attr audio_attr whiteboard_attr\n\
    global ldata startdayofweek medialist sd_fmt media_fmt media_proto\n\
    global security\n\
    global yourphone\n\
    global youremail\n\
    global yourname\n\
    global new_createtime\n\
    if {[string length $yourphone]==0} {\n\
	enter_phone_details\n\
	return\n\
    }\n\
\n\
    catch {destroy .new}\n\
    toplevel .new\n\
\n\
    posn_win .new\n\
    if {[string compare $aid \"new\"]!=0} {\n\
	wm title .new \"Sdr: [tt \"Edit Session\"]\"\n\
	foreach i $medialist {\n\
            set send($i) 0\n\
        }\n\
  	set new_createtime $ldata($aid,createtime)\n\
    } else {\n\
	wm title .new \"Sdr: [tt \"Create New Session\"]\"\n\
	foreach i $medialist {\n\
	    set send($i) 0\n\
	}\n\
	set send(audio) 1\n\
	set new_createtime [unix_to_ntp [gettimeofday]]\n\
    }\n\
\n\
\n\
    new_mk_session_name .new $aid\n\
    new_mk_session_desc .new $aid\n\
    new_mk_session_url .new $aid\n\
\n\
    if {[string compare $aid \"new\"]!=0} {\n\
	set sd_addr $ldata($aid,sd_addr)\n\
	set ttl $ldata($aid,ttl)\n\
	set scope ttl\n\
	set zone(cur_zone) $zone(ttl_scope)\n\
	for {set i 0} {$i<$zone(no_of_zones)} {incr i} {\n\
#	    puts \"$zone(sd_addr,$i)==$sd_addr)&&($zone(ttl,$i)==$ttl)\"\n\
	    if {($zone(sd_addr,$i)==$sd_addr)&&($zone(ttl,$i)==$ttl)} {\n\
#		puts \"setting zone(cur_zone) $i\"\n\
		set scope admin\n\
		set zone(cur_zone) $i\n\
	    }\n\
	}\n\
    } else {\n\
	set scope admin\n\
	set zone(cur_zone) 0\n\
	set ttl $zone(ttl,$zone(cur_zone))\n\
    }\n\
\n\
\n\
    frame .new.f3\n\
    pack .new.f3 -side top -pady 5 -fill x -expand true\n\
\n\
    catch {\n\
	new_mk_session_security .new.f3.l $aid\n\
    }\n\
\n\
    frame .new.f3.m -width 1 -height 1\n\
    pack .new.f3.m -side left -fill y -padx 3\n\
    frame .new.f3.r -relief groove -borderwidth 2\n\
    pack .new.f3.r -side left -fill both -expand true\n\
\n\
    new_mk_session_type .new.f3.r top $aid\n\
\n\
    label .new.f3.r.l2 -text \"Scope Mechanism:\"\n\
    pack .new.f3.r.l2 -side top -anchor nw\n\
    radiobutton .new.f3.r.b3 -text \"TTL Scope\" \\\n\
	-highlightthickness 0 \\\n\
	-variable scope -value ttl -relief flat -command \\\n\
	[format { \n\
	    set addr [generate_address %s]\n\
	    if {$addr!=0} {\n\
		pack .new.f3.rr -after .new.f3.m2 -side left -fill both \\\n\
		    -expand true\n\
		pack forget .new.f3.admin\n\
		if {$addr!=1} {\n\
		    set_new_session_addr conference $addr\n\
		    foreach media $medialist {\n\
			if {$send($media)==1} {\n\
			    set_new_session_addr $media [generate_address]\n\
			}\n\
		    }\n\
		}\n\
		set zone(cur_zone) $zone(ttl_scope)\n\
		set scope ttl\n\
		set_ttl_scope $ttl\n\
	    } else {\n\
		set scope admin\n\
	    }\n\
	} $aid ]\n\
    pack .new.f3.r.b3 -side top -anchor nw\n\
    radiobutton .new.f3.r.b4 -text \"Admin Scope\" \\\n\
	-highlightthickness 0 \\\n\
	-variable scope -value admin -relief flat -command \\\n\
	[format { \n\
	    # Recover the previously-selected scope if one clicks\n\
	    # on \"admin\" then \"ttl\" then \"admin\".\n\
	    #\n\
	    set tmpzone 0\n\
	    for {set i 0} {$i < $zone(no_of_zones)} {incr i} {\n\
		if {[string compare \\\n\
		     [.new.f3.admin.f.lb tag cget line$i -background] \\\n\
			 [option get . activeBackground Sdr]]==0} {\n\
			     set tmpzone $i\n\
			     break\n\
			 }\n\
	    }\n\
	    set addr [generate_address $zone(base_addr,$tmpzone) \\\n\
                         $zone(netmask,$tmpzone) %s]\n\
	    if {$addr!=0} {\n\
		set zone(cur_zone) $tmpzone\n\
		pack .new.f3.admin -after .new.f3.m2 -side left -fill both \\\n\
		    -expand true\n\
		pack forget .new.f3.rr\n\
		if {$addr!=1} {\n\
		    set_new_session_addr conference $addr\n\
		    foreach media $medialist {\n\
			if {$send($media)==1} {\n\
			    set_new_session_addr $media \\\n\
				[generate_address \\\n\
				 $zone(base_addr,$zone(cur_zone)) \\\n\
				     $zone(netmask,$zone(cur_zone))]\n\
			}\n\
		    }\n\
		}\n\
		set scope admin\n\
		set ttl $zone(ttl,$zone(cur_zone))\n\
	    } else {\n\
		set scope ttl\n\
	    }\n\
	    unset tmpzone\n\
	} $aid]\n\
    pack .new.f3.r.b4 -side top -anchor nw\n\
\n\
    hlfocus .new.f3.r.b3\n\
    hlfocus .new.f3.r.b4\n\
    #padding frame\n\
    pack [frame .new.f3.m2 -width 1 -height 1] -side left -fill y -padx 3\n\
\n\
    #admin scope frame\n\
    frame .new.f3.admin -relief groove -borderwidth 2\n\
    if {$scope==\"admin\"} {pack .new.f3.admin -side left -fill both -expand true}\n\
    label .new.f3.admin.l -text Scope:\n\
    pack .new.f3.admin.l -side top -anchor w\n\
    frame .new.f3.admin.f -relief sunken -borderwidth 1\n\
    pack .new.f3.admin.f -side top -fill both -expand true\n\
    text .new.f3.admin.f.lb -width 15 -height 6 -relief flat -wrap none\n\
    pack .new.f3.admin.f.lb -side top -fill both -expand true\n\
    for {set i 0} {$i < $zone(no_of_zones)} {incr i} {\n\
	.new.f3.admin.f.lb insert [expr $i+1].0 \"$zone(name,$i)\"\n\
	.new.f3.admin.f.lb tag add line$i [expr $i+1].0 end-1c\n\
	.new.f3.admin.f.lb tag configure line$i -background\\\n\
	    [option get . background Sdr]\n\
	.new.f3.admin.f.lb insert end \" \\n\"\n\
	.new.f3.admin.f.lb tag bind line$i <1> \\\n\
	    [format {\n\
		set addr [generate_address $zone(base_addr,%s) \\\n\
			  $zone(netmask,%s) %s]\n\
		if {$addr!=0} {\n\
		    #the change of scope is OK\n\
		    for {set i 0} {$i < $zone(no_of_zones)} {incr i} {\n\
			.new.f3.admin.f.lb tag configure line$i -background\\\n\
			    [option get . background Sdr]\n\
		    }\n\
		    .new.f3.admin.f.lb tag configure line%s -background\\\n\
			[option get . activeBackground Sdr]\n\
		    set ttl $zone(ttl,%s)\n\
		    if {$addr!=1} {\n\
			#and we can reallocated the addresses too.\n\
			set_new_session_addr conference $addr\n\
			foreach media $medialist {\n\
			    if {$send($media)==1} {\n\
				set_new_session_addr $media \\\n\
				    [generate_address $zone(base_addr,%s) \\\n\
				     $zone(netmask,%s)]\n\
			    }\n\
			}\n\
		    }\n\
		    set zone(cur_zone) %s\n\
		}\n\
	    } $i $i $aid $i $i $i $i $i]\n\
    }\n\
    .new.f3.admin.f.lb configure -state disabled\n\
    .new.f3.admin.f.lb tag configure line$zone(cur_zone) -background\\\n\
	[option get . activeBackground Sdr]\n\
\n\
    \n\
    frame .new.f3.rr -relief groove -borderwidth 2\n\
    tixAddBalloon .new.f3.rr Frame [tt \"The scope determines how far your session will reach.  The default values are:\n\
\n\
Local net: 1\n\
Site:      15\n\
Region:    63\n\
World:     127\n\
\n\
Specify the smallest scope that will reach the people you want to communicate with.\"]\n\
\n\
    label .new.f3.rr.l -text [tt \"Scope\"]\n\
    radiobutton .new.f3.rr.r1 -relief flat -text [tt \"Site\"] -variable ttl\\\n\
	-highlightthickness 0 \\\n\
	-value 15 -command {disable_scope_entry 15}\n\
    radiobutton .new.f3.rr.r2 -relief flat -text [tt \"Region\"] -variable ttl\\\n\
	-highlightthickness 0 \\\n\
	-value 63 -command {disable_scope_entry 63}\n\
    radiobutton .new.f3.rr.r3 -relief flat -text [tt \"World\"] -variable ttl\\\n\
	-highlightthickness 0 \\\n\
	-value 127 -command {disable_scope_entry 127}\n\
    hlfocus .new.f3.rr.r1\n\
    hlfocus .new.f3.rr.r2\n\
    hlfocus .new.f3.rr.r3\n\
    frame .new.f3.rr.f\n\
    if {[string compare $aid \"new\"]==0} {\n\
	radiobutton .new.f3.rr.f.r4 -relief flat -variable ttl\\\n\
	    -highlightthickness 0 \\\n\
	    -command \"enable_scope_entry 1\" -value 0\n\
    } else {\n\
	radiobutton .new.f3.rr.f.r4 -relief flat -variable ttl\\\n\
	    -highlightthickness 0 \\\n\
	    -command \"enable_scope_entry $ttl\" -value 0\n\
    }\n\
    entry .new.f3.rr.f.e -relief sunken -width 4 -text 1 \\\n\
	-bg [option get . entryBackground Sdr] \\\n\
	 -highlightthickness 0\n\
    .new.f3.rr.f.e insert 0 $ttl\n\
    proc disable_scope_entry {value} {\n\
	.new.f3.rr.f.e configure -state normal\n\
	.new.f3.rr.f.e delete 0 end\n\
	.new.f3.rr.f.e insert 0 $value\n\
	.new.f3.rr.f.e configure -state disabled \\\n\
	    -background [option get . background Sdr]\\\n\
	    -relief groove\n\
    }\n\
    proc enable_scope_entry {ttl} {\n\
	.new.f3.rr.f.e configure -state normal \\\n\
            -background [option get . entryBackground Sdr]\\\n\
            -relief sunken\n\
	.new.f3.rr.f.e delete 0 end\n\
        .new.f3.rr.f.e insert 0 $ttl\n\
    }\n\
    bind .new.f3.rr.f.e <1> {\n\
	.new.f3.rr.f.r4 invoke\n\
	.new.f3.rr.f.e icursor end\n\
	focus .new.f3.rr.f.e\n\
    }\n\
    pack .new.f3.rr.f.r4 -side left\n\
    pack .new.f3.rr.f.e -side left\n\
    if {[string compare $aid \"new\"]!=0} {\n\
	set ttl $ldata($aid,ttl)\n\
	if {$scope==\"ttl\"} {\n\
	    set_ttl_scope $ttl\n\
	}\n\
    } else {\n\
	if {$scope==\"ttl\"} {\n\
	    .new.f3.rr.r1 invoke\n\
	}\n\
    }\n\
    pack .new.f3.rr.l -side top -anchor w\n\
    pack .new.f3.rr.r1 -side top -anchor w\n\
    pack .new.f3.rr.r2 -side top -anchor w\n\
    pack .new.f3.rr.r3 -side top -anchor w\n\
    pack .new.f3.rr.f -side top -anchor w\n\
    if {$scope==\"ttl\"} {pack .new.f3.rr -side left -fill both -expand true}\n\
\n\
\n\
    set show_details 1\n\
    new_mk_session_media .new.f1 $aid $scope $show_details\n\
\n\
    frame .new.f2\n\
    frame .new.f2.act -relief groove -borderwidth 2\n\
    pack .new.f2.act -side left -fill both -expand true\n\
    pack .new.f2 -side top -pady 5 -fill x -expand true\n\
    pack [frame .new.f2.act.l] -side top -anchor w\n\
    label .new.f2.act.l.icon -bitmap clock\n\
    pack .new.f2.act.l.icon -side left\n\
    label .new.f2.act.l.l -text \"Session will be active:\" \n\
    pack .new.f2.act.l.l -side left\n\
\n\
    global rpt_times\n\
    global has_times\n\
    global needs_lifetime\n\
    global rpt_min_values \n\
    global rpt_menu_value\n\
    global duration_max\n\
\n\
    set rpt_times {{---} {Once} {Daily} {Weekly} {Every Two Weeks}\\\n\
     {Monthly by Date} {Monday thru Friday}}\n\
\n\
    #whether of not the times box should be active \n\
    set has_times {0 1 1 1 1 1 1}\n\
\n\
    set menu_disabled {0 0 0 0 0 1 1}\n\
\n\
    #whether or not there is a repeat time\n\
    set needs_lifetime {0 0 1 1 1 1 1}\n\
\n\
    #what the default minimum repeat time should be\n\
    set rpt_min_values {0 0 2880 20160 40320 40320 20160}\n\
\n\
    #what the max duration should be for each repeat interval\n\
    set duration_max {0 4838400 43200 518400 1036800 0 604800}\n\
\n\
    set rpt_menu_value(1) 1\n\
    set rpt_menu_value(2) 0\n\
    set rpt_menu_value(3) 0\n\
    foreach box {1 2 3} {\n\
	new_mk_session_time_box .new.f2.act.f$box $box 3 $rpt_times $menu_disabled\n\
    }\n\
    pack [frame .new.f2.act.fd] -side top -anchor w\n\
    pack [label .new.f2.act.fd.l -text \"Repeat for:\"] -side left -anchor w\n\
    duration_widget .new.f2.act.fd.duration 3600\n\
    configure_duration_box .new.f2.act.fd 3\n\
    if {[string compare $aid \"new\"]!=0} {\n\
	set rpts 0\n\
	set maxdiff 0\n\
	for {set t 0} {$t < $ldata($aid,no_of_times)} {incr t} {\n\
	    if {$ldata($aid,time$t,no_of_rpts)==0} {\n\
		.new.f2.act.fb[expr $t+1].day.workaround configure \\\n\
		    -time $ldata($aid,starttime,$t)		\n\
		.new.f2.act.fb[expr $t+1].time.workaround configure \\\n\
		    -time $ldata($aid,starttime,$t)\n\
		.new.f2.act.fb[expr $t+1].duration.workaround configure -time \\\n\
		    [expr $ldata($aid,endtime,$t) - $ldata($aid,starttime,$t)]\n\
		set rpt_menu_value([expr $t+1]) 1\n\
		configure_rpt_menu [expr $t+1] .new.f2.act.fb[expr $t+1]\n\
	    } else {\n\
		set rpts 1\n\
		for {set r 0} {$r < $ldata($aid,time$t,no_of_rpts)} {incr r} {\n\
		    if {$r>0} {puts \"too complicated - tragic!\"}\n\
		    if {$ldata($aid,time$t,offset$r)!=\"0\"} {\n\
			puts \"too many offsets! - tragic!\"\n\
		    }\n\
		    set start $ldata($aid,starttime,$t)\n\
		    set end $ldata($aid,endtime,$t)\n\
		    set dur $ldata($aid,time$t,duration$r)\n\
		    set ofs $ldata($aid,time$t,offset$r)\n\
		    if {[expr ($end-$start)-$dur]> $maxdiff } {\n\
			     set maxdiff [expr ($end-$start)-$dur]\n\
		    }\n\
		    .new.f2.act.fb[expr $t+1].day.workaround configure -time $start\n\
		    .new.f2.act.fb[expr $t+1].time.workaround configure -time $start\n\
		    .new.f2.act.fb[expr $t+1].duration.workaround configure -time $dur\n\
		    case $ldata($aid,time$t,interval$r) in {\n\
			86400 {set rpt_menu_value([expr $t+1]) 2}\n\
			604800 {\n\
			    if {$ofs==\"0\"} {\n\
				set rpt_menu_value([expr $t+1]) 3\n\
			    } elseif {$ofs==\"0 86400 172800 259200 345600\"} {\n\
				set rpt_menu_value([expr $t+1]) 6\n\
			    } else {\n\
				puts \"help - can't handle this weekly offset\"\n\
			    }\n\
			}\n\
			1209600 {set rpt_menu_value([expr $t+1]) 4}\n\
		    }\n\
		    configure_rpt_menu [expr $t+1] .new.f2.act.fb[expr $t+1]\n\
		}\n\
	    }\n\
	}\n\
	if {$rpts==1} {\n\
	    .new.f2.act.fd.duration.workaround configure -time $maxdiff\n\
	    .new.f2.act.fd.duration.workaround configure -state normal\n\
	}\n\
    }\n\
    new_mk_session_contact .new.you $aid\n\
\n\
    new_mk_session_buttons .new.f4 $aid\n\
    move_onscreen .new\n\
    log \"displaying technical session creation interface at [getreadabletime]\"\n\
}\n\
\n\
proc set_sess_type {win type} {\n\
    global sess_type\n\
    set sess_type $type\n\
    switch $type {\n\
	test {\n\
	    $win.m configure -text Test\n\
	}\n\
	broadcast {\n\
	    $win.m configure -text Broadcast\n\
	}\n\
	meeting {\n\
	    $win.m configure -text Meeting\n\
	}\n\
	other {\n\
	    $win.m configure -text Unspecified\n\
	}\n\
    }\n\
}\n\
\n\
proc new_mk_session_type {win order aid} {\n\
    global ldata typelist\n\
    label $win.l -text \"Type of Session:\"\n\
    pack $win.l -side $order -anchor nw\n\
    menubutton $win.m -menu $win.m.menu -width 10\\\n\
	-borderwidth 1 -relief raised\n\
    pack $win.m -side $order -anchor nw -padx 10\n\
    menu $win.m.menu -tearoff 0\n\
    foreach type $typelist {\n\
	$win.m.menu add command -label [get_type_name $type] \\\n\
		-command \"set_sess_type $win $type\"\n\
    }\n\
    if {[string compare $aid \"new\"]==0} {\n\
	set_sess_type $win test\n\
    } else {\n\
	set_sess_type $win $ldata($aid,type)\n\
    }\n\
}\n\
\n\
proc new_mk_session_name {win aid} {\n\
    global ldata\n\
    frame $win.f0\n\
    label $win.f0.l -text [tt \"Session Name:\"]\n\
    entry $win.f0.entry -width 30 -relief sunken\\\n\
	 -bg [option get . entryBackground Sdr] \\\n\
	 -highlightthickness 0\n\
    tixAddBalloon  $win.f0.entry Entry [tt \"Enter the name of the session here\"]\n\
    if {[string compare $aid \"new\"]!=0} { $win.f0.entry insert 0 $ldata($aid,session) }\n\
    pack $win.f0.l -side left\n\
    pack $win.f0.entry -side left -fill x -expand true\n\
    pack $win.f0 -side top -anchor w -fill x\n\
    proc get_new_session_name {win} {\n\
	$win.f0.entry get\n\
    }\n\
}\n\
\n\
proc new_mk_session_desc {win aid} {\n\
    global ldata\n\
    label $win.descl -text [tt \"Description:\"]\n\
    pack $win.descl -side top -anchor w\n\
    frame $win.df\n\
    text $win.df.desc -width 40 -height 5 -relief sunken -borderwidth 2 \\\n\
	 -bg [option get . entryBackground Sdr] -yscroll \"$win.df.sb set\"\\\n\
	-wrap word\n\
    scrollbar $win.df.sb -command \"$win.df.desc yview\" \\\n\
      -background [option get . scrollbarBackground Sdr] \\\n\
      -borderwidth 1 -relief flat\n\
#TBD\n\
#      -foreground [option get . scrollbarForeground Sdr] \\\n\
#      -activeforeground [option get . scrollbarActiveForeground Sdr] \n\
\n\
\n\
\n\
    tixAddBalloon $win.df.desc Text [tt \"Enter a short description of your session here\"]\n\
\n\
\n\
    #this shouldn't really list the widgets by name\n\
    bind $win.df.desc <Tab> \"focus $win.url.f0.e;break\"\n\
    bind $win.df.desc <Shift-Tab> \"focus $win.f0.entry;break\"\n\
\n\
    pack $win.df.desc -side left -fill both -expand true\n\
    pack $win.df.sb -side left -fill y\n\
    pack $win.df -side top -fill both -expand true\n\
    if {[string compare $aid \"new\"]!=0} { \n\
#	$win.df.desc insert 0.0 [text_wrap $ldata($aid,desc) 40] \n\
	$win.df.desc insert 0.0 $ldata($aid,desc)\n\
    }    \n\
    proc get_new_session_desc {} {\n\
	.new.df.desc get 0.0 end-1c\n\
    }\n\
}\n\
\n\
proc new_mk_session_url {win aid} {\n\
    global ldata\n\
    frame .new.url -borderwidth 2 -relief groove\n\
    pack .new.url -side top -fill x -expand true -ipady 2 -ipadx 2 -pady 2\n\
    frame .new.url.f0 \n\
    pack .new.url.f0 -side top -fill x -expand true\n\
    label .new.url.f0.l -text URL:\n\
    pack .new.url.f0.l -side left\n\
    entry .new.url.f0.e -width 30 -relief sunken -borderwidth 2 \\\n\
	-bg [option get . entryBackground Sdr] \\\n\
	 -highlightthickness 0\n\
    tixAddBalloon .new.url.f0.e Entry [tt \"You can enter a URL here to provide additional information about your session.\\n\\nA URL is a reference to a web page. E.g. http://www\"]\n\
    pack .new.url.f0.e -side left -fill x -expand true\n\
    button .new.url.f0.b -text \"Test URL\" \\\n\
	-highlightthickness 0 \\\n\
	-command \\\n\
	{ .new.url.f0.e select from 0; \\\n\
	  .new.url.f0.e select to end; \\\n\
	  catch {selection get} url; \\\n\
	  timedmsgpopup \"Testing URL - please wait\" $url 5000; \\\n\
	  stuff_mosaic }\n\
    tixAddBalloon .new.url.f0.b Button [tt \"Click here to test the URL entered in the box to the left of this button\"]\n\
    pack .new.url.f0.b -side left\n\
    if {[string compare $aid \"new\"]!=0} {\n\
	if {$ldata($aid,uri)!=0} {\n\
	    .new.url.f0.e insert 0 $ldata($aid,uri)\n\
	}\n\
    }\n\
    proc get_new_session_uri {} {\n\
	.new.url.f0.e get\n\
    }\n\
}\n\
\n\
proc new_mk_session_admin {win aid scope} {\n\
    global zone send medialist ttl ldata\n\
    #admin scope frame\n\
    frame $win -relief groove -borderwidth 2\n\
    if {$scope==\"admin\"} {pack $win -side left -fill both -expand true}\n\
    label $win.l -text \"Area Reached:\"\n\
\n\
    tixAddBalloon $win.l Label [tt \"The area reached determines the \\\n\
range of the session.  People outside this area will not be able to receive it.\"]\n\
\n\
    pack $win.l -side top -anchor w\n\
    pack [frame $win.f] -side top -fill both -expand true\n\
    text $win.f.lb -width 15 -height 6 -relief flat \\\n\
	 -relief sunken -borderwidth 1 -yscroll \"$win.f.sb set\" \\\n\
	 -highlightthickness 0\n\
    pack $win.f.lb -side left -fill both -expand true\n\
    scrollbar $win.f.sb -borderwidth 1 -command \"$win.f.lb yview\" \\\n\
	 -highlightthickness 0\n\
    pack $win.f.sb -side right -fill y -expand true\n\
    for {set i 0} {$i < $zone(no_of_zones)} {incr i} {\n\
	$win.f.lb insert [expr $i+1].0 \"$zone(name,$i)\"\n\
	$win.f.lb tag add line$i [expr $i+1].0 end-1c\n\
	$win.f.lb tag configure line$i -background\\\n\
	    [option get . background Sdr]\n\
	$win.f.lb insert end \" \\n\"\n\
	$win.f.lb tag bind line$i <1> \\\n\
	    [format {\n\
		set ttl $zone(ttl,%s)\n\
		set addr [generate_address $zone(base_addr,%s) \\\n\
			  $zone(netmask,%s) %s]\n\
		if {$addr!=0} { \\\n\
		    for {set i 0} {$i < $zone(no_of_zones)} {incr i} {\n\
			%s.f.lb tag configure line$i -background\\\n\
			    [option get . background Sdr]\n\
		    }\n\
		    %s.f.lb tag configure line%s -background\\\n\
                     [option get . activeBackground Sdr]\n\
		    if {$addr!=1} {\n\
			set_new_session_addr conference $addr\n\
			foreach media $medialist {\n\
			    if {$send($media)==1} {\n\
				set_new_session_addr $media \\\n\
				    [generate_address $zone(base_addr,%s) \\\n\
				     $zone(netmask,%s)]\n\
			    }\n\
			}\n\
		    }\n\
		    set zone(cur_zone) %s\n\
		}\n\
	    } $i $i $i $aid $win $win $i $i $i $i]\n\
    }\n\
    if {($scope==\"admin\")&&([string compare $aid \"new\"]==0)} {\n\
	set ttl $zone(ttl,0)\n\
    } elseif {[string compare $aid \"new\"]!=0} {\n\
	set ttl $ldata($aid,ttl)\n\
    } else {\n\
	set ttl 15\n\
    }\n\
    $win.f.lb configure -state disabled\n\
    $win.f.lb tag configure line$zone(cur_zone) -background\\\n\
	[option get . activeBackground Sdr]\n\
}\n\
\n\
proc new_mk_session_media {win aid scope show_details} {\n\
    global ldata zone medialist sd_menu send \n\
    global media_fmt media_proto media_attr\n\
    #multicast address and ttl\n\
    frame $win -relief groove -borderwidth 2\n\
    frame $win.f0\n\
    label $win.f0.l -text [tt \"Address:\"]\n\
    entry $win.f0.entry -width 20 -relief sunken\\\n\
	 -bg [option get . entryBackground Sdr] \\\n\
	 -highlightthickness 0\n\
    tixAddBalloon $win.f0.entry Entry [tt \"A multicast address has been assigned you.  If you need to modify this, change this entry.\n\
\n\
Multicast addresses must be class D IP addresses.  These are of the form\n\
      a.b.c.d \n\
where a is in the range 224 to 239 and b, c and d are in the range 0 to 255.\"]\n\
    if {[string compare $aid \"new\"]!=0} {\n\
	$win.f0.entry insert 0 $ldata($aid,multicast)	    \n\
    } else {\n\
        if {$scope==\"admin\"} {\n\
            $win.f0.entry insert 0 [generate_address $zone(base_addr,$zone(cur_zone)) $zone(netmask,$zone(cur_zone))]\n\
        } else {\n\
            $win.f0.entry insert 0 [generate_address]\n\
        }\n\
    }\n\
    pack $win.f0.l -side left\n\
    pack $win.f0.entry -side left -fill x -expand true\n\
\n\
    #Media\n\
    pack [frame $win.l] -side top -anchor w\n\
    label $win.l.1 -text [tt \"Media:\"] -anchor w -width 15\n\
    pack $win.l.1 -side left -anchor w -padx 10 \n\
    label $win.l.5 -text [tt \"Protocol\"] -anchor w -width 8\n\
    if {$show_details==1} {\n\
	pack $win.l.5 -side left -anchor w\n\
    }\n\
    label $win.l.2 -text [tt \"Format\"] -anchor w -width 10\n\
    pack $win.l.2 -side left -anchor w\n\
    label $win.l.3 -text [tt \"Address\"] -anchor w -width 14\n\
    if {($show_details==1)} {\n\
	pack $win.l.3 -side left -anchor w\n\
    }\n\
    label $win.l.4 -text [tt \"Port\"] -anchor w -width 6\n\
    if {$show_details==1} {\n\
	pack $win.l.4 -side left -anchor w \n\
    }\n\
\n\
    foreach attr [array names media_attr] {\n\
	unset media_attr($attr)\n\
    }\n\
    if {[string compare $aid \"new\"]!=0} {\n\
	for {set mnum 0} {$mnum < $ldata($aid,medianum)} {incr mnum} {\n\
	    set send($ldata($aid,$mnum,media)) 1\n\
#	    set media_attr($ldata($aid,$mnum,media)) $ldata($aid,$mnum,vars)\n\
#	    puts \"vars: $ldata($aid,$mnum,vars)\"\n\
	    foreach var $ldata($aid,$mnum,vars) {\n\
		set key [lindex [split $var \":\"] 0]\n\
		set value [lindex [split $var \":\"] 1]\n\
		if {$value==\"\"} {\n\
		    set media_attr($ldata($aid,$mnum,media),$key) 1\n\
		} else {\n\
		    set media_attr($ldata($aid,$mnum,media),$key) $value\n\
		}\n\
	    }\n\
	}\n\
    }\n\
    \n\
    foreach media $medialist {\n\
	frame $win.$media\n\
	pack $win.$media -side top -anchor w  -padx 10 -pady 2\n\
\n\
	button $win.$media.cb -command \"togglemedia $win $media\"\n\
	pack $win.$media.cb -side left\n\
	iconbutton $win.$media.mb -text $media -bitmap [get_icon $media] -width 10 -relief raised\\\n\
	    -menu $win.$media.mb.menu \n\
	pack $win.$media.mb -side left -fill y\n\
	create_menu $win.$media.mb.menu \"\" \"\" $media \"create\"\n\
\n\
	menubutton $win.$media.fmt -width 8  -relief raised\\\n\
	    -menu $win.$media.fmt.menu\n\
	create_fmt_menu $win $win.$media.fmt \\\n\
	    [get_media_fmts $media [lindex [get_media_protos $media] 0]] $media\n\
\n\
	menubutton $win.$media.proto -width 6 -relief raised\\\n\
	    -menu $win.$media.proto.menu\n\
	create_proto_menu $win $win.$media.proto $win.$media.fmt \\\n\
	    [get_media_protos $media] $media\n\
\n\
	entry $win.$media.addr -width 14 -relief sunken\\\n\
	    -bg [option get . entryBackground Sdr] \\\n\
	     -highlightthickness 0\n\
	entry $win.$media.port -width 6 -relief sunken\\\n\
	    -bg [option get . entryBackground Sdr] \\\n\
	     -highlightthickness 0\n\
	set media_fmt($media) \\\n\
	    [lindex [get_media_fmts $media [lindex [get_media_protos $media] 0]] 0]\n\
	set media_proto($media) [lindex [get_media_protos $media] 0]\n\
	if {([string compare $aid \"new\"]==0)&&($send($media)==1)} {\n\
	    if {$scope==\"admin\"} {\n\
		$win.$media.addr insert 0 [generate_address $zone(base_addr,$zone(cur_zone)) $zone(netmask,$zone(cur_zone))]\n\
	    } else {\n\
		$win.$media.addr insert 0 [generate_address]\n\
	    }\n\
	    setmediamode $media $win $send($media) 1\n\
	} elseif {([string compare $aid \"new\"]!=0)&&($send($media)==1)} { \n\
	    setmediaflags $media $win $aid \n\
	    setmediamode $media $win $send($media) 0\n\
	} else {\n\
	    setmediamode $media $win $send($media) 0\n\
	}\n\
\n\
	if {$show_details==1} {\n\
	    pack $win.$media.proto -side left -fill y -padx 2\n\
	}\n\
	pack $win.$media.fmt -side left -fill y -padx 2\n\
	if {$show_details==1} {\n\
	    pack $win.$media.addr -side left -padx 2\n\
	    pack $win.$media.port -side left -padx 2\n\
	}\n\
    }\n\
    \n\
\n\
    if {$show_details==1} {\n\
	pack $win -fill x -side top -anchor w -pady 5\n\
    } else {\n\
	pack $win -fill both -expand true -side top -anchor nw\n\
    }\n\
    proc get_new_session_addr {media} [format {\n\
	if {$media==\"conference\"} {\n\
           %s.f0.entry get\n\
        } else {\n\
           %s.$media.addr get\n\
        }\n\
    } $win $win]\n\
    proc set_new_session_addr {media str} [format {\n\
        if {$media==\"conference\"} {\n\
           %s.f0.entry delete 0 end\n\
	    %s.f0.entry insert 0 $str\n\
       } else {\n\
           %s.$media.addr delete 0 end\n\
	   %s.$media.addr insert 0 $str\n\
       }\n\
    } $win $win $win $win]\n\
\n\
\n\
    proc get_new_session_port {media} [format {\n\
	%s.$media.port get\n\
    } $win ]\n\
    proc get_new_session_proto {media} {\n\
    }\n\
    proc get_new_session_format {media} {\n\
    }\n\
}\n\
\n\
\n\
proc new_mk_session_time_box {win box maxbox rpt_times menu_disabled} {\n\
    global ifstyle\n\
    if {($box==1)&&($ifstyle(create)==\"norm\")} {\n\
	label .new.f2.act.expl -font [resource infoFont] -text \\\n\
	    \"how often it takes place               when it first takes place                                      how long each time\"\n\
	pack .new.f2.act.expl -side top\n\
    }\n\
    frame .new.f2.act.fb$box\n\
    set mb .new.f2.act.fb$box.m\n\
    menubutton $mb  -width 20 -anchor w\\\n\
	-relief raised -borderwidth 1 -menu $mb.m\n\
    menu $mb.m -tearoff 0\n\
    pack $mb -side left -anchor w\n\
    set ctr 0\n\
    foreach i $rpt_times {\n\
	if {[lindex $menu_disabled $ctr]==0} {\n\
	    $mb.m add command -label $i -command \"\\\n\
		    $mb configure -text \\\"$i\\\";\\\n\
                    set rpt_menu_value($box) $ctr;\\\n\
                    configure_rpt_menu $box .new.f2.act.fb$box;\\\n\
                    configure_duration_box .new.f2.act.fd $maxbox\"\n\
	} else {\n\
	    $mb.m add command -label $i -state disabled\n\
	}\n\
	incr ctr\n\
    }\n\
    pack .new.f2.act.fb$box -side top\n\
    pack [label .new.f2.act.fb$box.l -text \"from:\"] -side left\n\
    day_widget .new.f2.act.fb$box.day now\n\
    pack [label .new.f2.act.fb$box.l1 -text \"at\"] -side left\n\
    time_widget .new.f2.act.fb$box.time now\n\
    pack [label .new.f2.act.fb$box.l2 -text \"for\"] -side left\n\
    duration_widget .new.f2.act.fb$box.duration 7200\n\
    pack [frame .new.f2.act.pad$box -height 10] -side top\n\
    configure_rpt_menu $box .new.f2.act.fb$box\n\
}\n\
\n\
proc new_mk_session_contact {win aid} {\n\
    global ldata yourname yourphone youremail\n\
    frame $win -relief groove -borderwidth 2\n\
    label $win.l -text \"Person to contact about this session:\"\n\
\n\
    tixAddBalloon $win.l Label [tt \"Name, email address and telephone \\\n\
number of person to be contacted about the session. You can \\\n\
edit the suggested address and telephone number. To edit the \\\n\
default, choose \\\"Preferences\\\" in the session main session \\\n\
window, then \\\"You\\\".\"]\n\
\n\
    pack $win.l -side top -anchor nw\n\
    frame $win.f0 \n\
    pack $win.f0 -side top -pady 3\n\
\n\
    label $win.f0.l -bitmap mail -anchor w\n\
    pack $win.f0.l -side left -fill x -anchor s\n\
    entry $win.f0.e -width 35 -relief sunken \\\n\
	-bg [option get . entryBackground Sdr] \\\n\
	 -highlightthickness 0\n\
    tixAddBalloon $win.f0.e Entry [tt \"Enter your name and email address here\"]\n\
    pack $win.f0.e -side bottom -anchor sw\n\
\n\
\n\
    frame $win.f1 \n\
    pack $win.f1 -side top\n\
    label $win.f1.l -bitmap phone -anchor w\n\
    pack $win.f1.l -side left -fill x\n\
    entry $win.f1.e -width 35 -relief sunken \\\n\
	-bg [option get . entryBackground Sdr] \\\n\
	 -highlightthickness 0\n\
    tixAddBalloon $win.f1.e Entry [tt \"Enter your telephone number here\"]\n\
    pack $win.f1.e -side left -fill x -expand true\n\
    pack $win -side top -fill both -expand true\n\
\n\
    if {[string compare $aid \"new\"]!=0} { \n\
 	foreach p $ldata($aid,phonelist) {\n\
	    $win.f1.e insert 0 $p\n\
	}\n\
	foreach e $ldata($aid,emaillist) {\n\
	    $win.f0.e insert 0 $e\n\
	}\n\
   } else {\n\
       $win.f1.e insert 0 \"$yourname $yourphone\"\n\
       $win.f0.e insert 0 \"$yourname <$youremail>\"\n\
    }\n\
}\n\
\n\
proc new_mk_session_buttons {win aid} {\n\
    frame $win\n\
    if {[string compare $aid \"new\"]!=0} {\n\
	button $win.create -text [tt \"Modify\"] -command \\\n\
	    \"if {\\[create\\]==1} \\\n\
                { ui_stop_session_ad $aid;\\\n\
                  destroy .new}\"\n\
	tixAddBalloon $win.create Button [tt \"Click here to advertise the modified session.  \n\
\n\
Changing the session name may result in some sites seeing duplicate announcements for a while.\"]\n\
    } else {\n\
	button $win.create -text [tt \"Create\"] -command \\\n\
	    \"if {\\[create\\]==1} {destroy .new}\" \\\n\
	     -highlightthickness 0\n\
	tixAddBalloon $win.create Button [tt \"When you've filled out all the above information, click here to create and advertise this session\"]\n\
    }\n\
    button $win.cal -text [tt \"Show Daily Listings\"] -command \"calendar\" \\\n\
	 -highlightthickness 0\n\
    tixAddBalloon $win.cal Button [tt \"Click here to show a calendar of current sessions\"]\n\
    button $win.help -text [tt \"Help\"] -command \"help\" \\\n\
	 -highlightthickness 0\n\
    tixAddBalloon $win.help Button [tt \"Click here for more help or to turn balloon help off\"]\n\
\n\
    button $win.dismiss -text \"Dismiss\" -command \"destroy .new\" \\\n\
	 -highlightthickness 0\n\
    tixAddBalloon $win.dismiss Button [tt \"Click here to close this window\"]\n\
    pack $win.create -side left -fill x -expand true\n\
    pack $win.cal -side left -fill x -expand true\n\
    pack $win.help -side left -fill x -expand true\n\
    pack $win.dismiss -side left -fill x -expand true\n\
    pack $win -fill x\n\
}\n\
\n\
proc set_ttl_scope {ttl} {\n\
    case $ttl {\n\
	15 { .new.f3.rr.r1 invoke;return}\n\
	63 { .new.f3.rr.r2 invoke;return}\n\
	127 {.new.f3.rr.r3 invoke;return}\n\
	default {\n\
#	    puts $ttl\n\
	    .new.f3.rr.f.r4 invoke\n\
	}\n\
    }\n\
}\n\
proc day_widget {widget time} {\n\
    global $widget\n\
    frame $widget\n\
    if {$time!=\"now\"} {\n\
	set [set widget](startdayofweek) [lindex [gettime $time] 5]\n\
	set [set widget](monthix) [fixint [lindex [gettime $time] 1]]\n\
	set [set widget](dayofmonth) [fixint [lindex [gettime $time] 2]]\n\
    } else {\n\
	set [set widget](startdayofweek) [lindex [gettimenow] 5]\n\
	set [set widget](monthix) [fixint [lindex [gettimenow] 1]]\n\
	set [set widget](dayofmonth)  [fixint [lindex [gettimenow] 2]]\n\
    }\n\
    set [set widget](dayix) 0\n\
    set [set widget](today_day) \\\n\
	[getdayname [set [set widget](startdayofweek)]]\n\
    set [set widget](today_mon) [getmonname [set [set widget](monthix)]]\n\
    label $widget.bx -relief sunken -width 10 -text \\\n\
	\"[set [set widget](today_day)] [set [set widget](dayofmonth)] [set [set widget](today_mon)]\"\n\
\n\
    frame $widget.f\n\
    button $widget.f.up -bitmap uparrow -relief flat \\\n\
	-borderwidth 0 -command \"changeday $widget 1\" \\\n\
	-highlightthickness 0\n\
    button $widget.f.down -bitmap downarrow -relief flat \\\n\
	-borderwidth 0 -command \"changeday $widget -1\" \\\n\
	-highlightthickness 0\n\
    pack $widget.f.up -side top\n\
    pack $widget.f.down -side bottom\n\
    pack $widget.f -side right\n\
    pack $widget.bx -side right\n\
    pack $widget -side left\n\
\n\
    proc $widget.workaround {command args} [format {\n\
	global %s\n\
	case $command {\n\
	    configure { configure_day_widget %s [lindex $args 0] [lindex $args 1] }\n\
	    get { \n\
		return [set %s(dayix)]\n\
	    }\n\
	}\n\
    } $widget $widget $widget $widget]\n\
}\n\
\n\
proc configure_day_widget {widget flag value} {\n\
    global $widget\n\
    case $flag {\n\
	\"-state\" {\n\
	    case $value {\n\
		disabled {\n\
		    $widget.f.up configure -state disabled\n\
		    $widget.f.down configure -state disabled\n\
		    $widget.bx configure \\\n\
			-relief groove\\\n\
			-fg [option get . background Sdr]\n\
		}\n\
		normal {\n\
		    $widget.f.up configure -state normal\n\
		    $widget.f.down configure -state normal\n\
		    $widget.bx configure \\\n\
			-relief sunken\\\n\
			-fg [option get . foreground Sdr]\n\
		}\n\
	    }\n\
	}\n\
	\"-time\" {\n\
	    set [set widget](startdayofweek) [lindex [gettime $value] 5]\n\
	    set [set widget](monthix) [fixint [lindex [gettime $value] 1]]\n\
	    set [set widget](dayofmonth) [fixint [lindex [gettime $value] 2]]\n\
	    set [set widget](dayix) 0\n\
	    set [set widget](today_day) \\\n\
		[getdayname [set [set widget](startdayofweek)]]\n\
	    set [set widget](today_mon) [getmonname [set [set widget](monthix)]]\n\
	    $widget.bx configure -text \\\n\
		\"[set [set widget](today_day)] [set [set widget](dayofmonth)] [set [set widget](today_mon)]\"\n\
	}\n\
    }\n\
}\n\
\n\
proc changeday {widget change} {\n\
    global $widget daysinmonth\n\
    if {($change < 0)&&([set [set widget](dayix)] >= [expr 0 - $change])} {\n\
	set [set widget](dayix) [expr [set [set widget](dayix)] + $change]\n\
	set [set widget](dayofmonth) [expr [set [set widget](dayofmonth)] +  $change]\n\
\n\
    }\n\
    if {$change > 0} {\n\
	set [set widget](dayix) [expr [set [set widget](dayix)] + $change]\n\
	set [set widget](dayofmonth) [expr [set [set widget](dayofmonth)] +  $change]\n\
    }\n\
    \n\
    set thismonthlen [lindex $daysinmonth [expr [set [set widget](monthix)] - 1]]\n\
    if {[set [set widget](dayofmonth)] > $thismonthlen} {\n\
	set [set widget](dayofmonth) [expr [set [set widget](dayofmonth)] - $thismonthlen]\n\
	incr [set widget](monthix)\n\
	if {[set [set widget](monthix)]==13} {set [set widget](monthix) 1}\n\
    } \n\
    if {[set [set widget](dayofmonth)]==0} {\n\
	incr [set widget](monthix) -1\n\
	if {[set [set widget](monthix)]==0} {set [set widget](monthix) 12}\n\
        set thismonthlen [lindex $daysinmonth [expr [set [set widget](monthix)] - 1]]\n\
	set [set widget](dayofmonth) $thismonthlen\n\
    }\n\
    set tmpday [expr ([set [set widget](dayix)] + [set [set widget](startdayofweek)]) % 7]\n\
    $widget.bx configure -text \\\n\
	\"[getdayname $tmpday] [set [set widget](dayofmonth)] [getmonname [set [set widget](monthix)]]\"\n\
}\n\
\n\
proc time_widget {widget time} {\n\
    global $widget\n\
    if {$time!=\"now\"} {\n\
	set [set widget](timeofday) $time\n\
    } else {\n\
	set [set widget](timeofday) [expr [format %d [expr [gettimeofday] / 1800]] * 1800]\n\
    }\n\
    frame $widget\n\
    if {$time!=\"now\"} {\n\
	label $widget.bx -relief sunken -width 5 \\\n\
	    -text [timethen $widget $time]\n\
    } else {\n\
	label $widget.bx -relief sunken -width 5 -text [timenow $widget]\n\
    }\n\
    frame $widget.f\n\
    button $widget.f.up -bitmap uparrow -relief flat -borderwidth 0 \\\n\
	-command \"$widget.bx configure -text \\[changetime $widget 1\\]\" \\\n\
	-highlightthickness 0\n\
    button $widget.f.down -bitmap downarrow -relief flat -borderwidth 0 -command \"$widget.bx configure -text \\[changetime $widget -1\\]\" \\\n\
	-highlightthickness 0\n\
    pack $widget.f.up -side top\n\
    pack $widget.f.down -side top\n\
    pack $widget.f -side right\n\
    pack $widget.bx -side right\n\
    pack $widget -side left\n\
    proc $widget.workaround {command args} [format {\n\
	global %s\n\
	case $command {\n\
	    configure { configure_time_widget %s [lindex $args 0] [lindex $args 1] }\n\
	    get { \n\
		return [set %s(timeofday)]\n\
	    }\n\
	}\n\
    } $widget $widget $widget $widget]\n\
}\n\
\n\
proc configure_time_widget {widget flag value} {\n\
    global $widget\n\
    case $flag {\n\
	\"-state\" {\n\
	    case $value {\n\
		disabled {\n\
		    $widget.f.up configure -state disabled\n\
		    $widget.f.down configure -state disabled\n\
		    $widget.bx configure \\\n\
			-relief groove\\\n\
			-fg [option get . background Sdr]\n\
		}\n\
		normal {\n\
		    $widget.f.up configure -state normal\n\
		    $widget.f.down configure -state normal\n\
		    $widget.bx configure \\\n\
			-relief sunken\\\n\
			-fg [option get . foreground Sdr]\n\
		}\n\
	    }\n\
	}\n\
	\"-time\" {\n\
	    set [set widget](timeofday) $value\n\
	    $widget.bx configure -text [timethen $widget $value]\n\
	}\n\
    }\n\
}\n\
\n\
proc changetime {widget change} {\n\
    global $widget\n\
\n\
    #we may have got given a hour with a leading zero - if so remove it\n\
    #to avoid confusing TCL\n\
    if {[string range [set [set widget](hrs)] 0 0] == \"0\"} {\n\
	if {[string length [set [set widget](hrs)]] == 2} {\n\
	    set [set widget](hrs) [string range [set [set widget](hrs)] 1 1]\n\
	}\n\
    }\n\
\n\
\n\
    if {$change == -1} {\n\
	if {[set [set widget](mins)]==30} {\n\
	    set [set widget](mins) 0\n\
	    if {[set [set widget](hrs)]<0} {set [set widget](hrs) 0;set [set widget](mins) 30} else {\n\
		incr [set widget](timeofday) -1800\n\
	    }\n\
	    \n\
	} else {\n\
	    if {[set [set widget](hrs)]!=0} {\n\
		set [set widget](mins) 30\n\
		incr [set widget](hrs) -1\n\
		incr [set widget](timeofday) -1800\n\
	    }\n\
	}\n\
    } else {\n\
	if {$change!=1} {puts \"odd change value $change\"}\n\
	if {[set [set widget](mins)]==0} {\n\
	    set [set widget](mins) 30\n\
	    incr [set widget](timeofday) 1800\n\
	} else {\n\
	    set [set widget](mins) 0\n\
	    incr [set widget](hrs) 1\n\
	    if {[set [set widget](hrs)] > 23} {set [set widget](hrs) 23; set [set widget](mins) 30} else {\n\
		incr [set widget](timeofday) 1800\n\
	    }\n\
	} \n\
    }\n\
    if {[set [set widget](hrs)] < 10} { set hrsstr 0[set [set widget](hrs)] } else {set hrsstr [set [set widget](hrs)]}\n\
    if {[set [set widget](mins)] < 10} { set minsstr 0[set [set widget](mins)] } else { set minsstr [set [set widget](mins)] }\n\
    return $hrsstr:$minsstr\n\
}\n\
\n\
proc timenow {widget} {\n\
    global $widget\n\
    set [set widget](hrs) [lindex [gettimenow] 3]\n\
    set [set widget](mins) [lindex [gettimenow] 4]\n\
    if {[set [set widget](mins)] < 30} {\n\
	set [set widget](mins) \"00\"\n\
    } else {\n\
	set [set widget](mins) 30\n\
    }\n\
    return [set [set widget](hrs)]:[set [set widget](mins)]\n\
}\n\
\n\
proc timethen {widget t} {\n\
    global $widget\n\
    set [set widget](hrs) [lindex [gettime $t] 3]\n\
    set [set widget](mins) [lindex [gettime $t] 4]\n\
    return [set [set widget](hrs)]:[set [set widget](mins)]\n\
}\n\
\n\
proc duration_widget {widget duration} {\n\
    global $widget \n\
    set [set widget](durationix) [get_duration_ix_by_time $duration]\n\
    #max time of 8 weeks\n\
    set [set widget](duration_max) 4838400 \n\
    set [set widget](duration_min) 0\n\
    if {$duration!=0} {\n\
	frame $widget\n\
	label $widget.bx -relief sunken -width 10 \\\n\
	    -text [get_duration [set [set widget](durationix)]]\n\
	frame $widget.f\n\
	button $widget.f.up -bitmap uparrow -relief flat -borderwidth 0 \\\n\
	    -highlightthickness 0 \\\n\
	    -command [format {\n\
                incr %s(durationix)\n\
		if {[set %s(durationix)] > 28} {\n\
		    set %s(durationix) 28\n\
		}\n\
		if {[expr [get_realduration [set %s(durationix)]]*60] > [set %s(duration_max)]} {\n\
		    incr %s(durationix) -1\n\
		}\n\
		%s.bx configure -text \\\n\
		    [get_duration [set %s(durationix)]]\n\
	    } $widget $widget $widget $widget $widget $widget $widget $widget]\n\
	button $widget.f.down -bitmap downarrow -relief flat -borderwidth 0 \\\n\
	    -highlightthickness 0 \\\n\
	    -command [format {\\\n\
		incr %s(durationix) -1;\n\
		if {[set %s(durationix)] < 0} {\n\
		    set %s(durationix) 0\n\
		};\n\
		if {[expr [get_realduration [set %s(durationix)]]*60] < [set %s(duration_min)]} {\n\
		    incr %s(durationix) 1\n\
		}\n\
		%s.bx configure -text \\\n\
		    [get_duration [set %s(durationix)]]\n\
	    } $widget $widget $widget $widget $widget $widget $widget $widget]\n\
	pack $widget.f.up -side top\n\
	pack $widget.f.down -side top\n\
	pack $widget.bx -side left\n\
	pack $widget.f -side left\n\
	pack $widget -side top -fill x -padx 3 -pady 2\n\
    } else {\n\
	label $widget -text [tt \"Permanent Session\"]\n\
	pack $widget -side top -anchor ne\n\
	set timeofday 0\n\
	set dayix 0\n\
	set [set widget](durationix) 0\n\
    }\n\
    proc $widget.workaround {command args} [format {\n\
	global %s\n\
        case $command {\n\
            configure { configure_duration_widget %s [lindex $args 0] [lindex $args \\\n\
1] }\n\
	    set {\n\
		#args 1 is time in minutes\n\
		set tmp [lindex $args 0]\n\
		catch {set tmp %s(duration_min)}\n\
		if {$tmp > [lindex $args 0]} {return 0}\n\
		set tmp [get_duration_ix_by_time [expr [lindex $args 0] * 60]]\n\
		set %s(durationix) $tmp\n\
		%s.bx configure -text \\\n\
		    [get_duration $tmp]\n\
	    }\n\
	    minval {\n\
		#args 1 is time in minutes\n\
		set %s(duration_min) [expr [lindex $args 0] * 60]\n\
	    }\n\
            get {\n\
		return [get_realduration [set %s(durationix)]]\n\
            }\n\
        }\n\
    } $widget $widget $widget $widget $widget $widget $widget $widget]\n\
\n\
}\n\
\n\
proc configure_duration_widget {widget flag value} {\n\
    global $widget\n\
    case $flag {\n\
	\"-state\" {\n\
	    case $value {\n\
		disabled {\n\
		    $widget.f.up configure -state disabled\n\
		    $widget.f.down configure -state disabled\n\
		    $widget.bx configure \\\n\
			-fg [option get . background Sdr]\\\n\
			-relief groove\n\
		}\n\
		normal {\n\
		    $widget.f.up configure -state normal\n\
		    $widget.f.down configure -state normal\n\
		    $widget.bx configure \\\n\
			-fg [option get . foreground Sdr]\\\n\
			-relief sunken\n\
		}\n\
	    }\n\
	}\n\
	\"-time\" {\n\
	    set [set widget](durationix) [get_duration_ix_by_time $value]\n\
	    $widget.bx configure -text [get_duration [set [set widget](durationix)]]\n\
	}\n\
    }\n\
}\n\
\n\
proc enter_phone_details {} {\n\
    global yourphone youremail yourname\n\
\n\
    if {($yourname==\"\" || $youremail==\"\") && [file exists \"~/.RTPdefaults\"]} {\n\
	option readfile \"~/.RTPdefaults\"\n\
	if {$yourname==\"\"} {\n\
	    set yourname [option get . rtpName Sdr]\n\
	}\n\
	if {$youremail==\"\"} {\n\
	    set youremail [option get . rtpEmail Sdr]\n\
	}\n\
    }\n\
    catch {destroy .phone}\n\
    toplevel .phone\n\
    wm title .phone \"Sdr: Configure\"\n\
    frame .phone.f -borderwidth 2 -relief groove\n\
    pack .phone.f -side top\n\
    message .phone.f.l -text \"Please configure sdr with your name, email address and phone number.  \n\
\n\
These will be given as the defaults when you create a session, but you will still be able to override them for each session\"\n\
    pack .phone.f.l -side top\n\
    frame .phone.f.f0 \n\
    pack .phone.f.f0 -side top -fill x -expand true\n\
    label .phone.f.f0.l -text \"Name:\"\n\
    pack .phone.f.f0.l -side left -anchor e -fill x -expand true\n\
    entry .phone.f.f0.e -width 40 -relief sunken -borderwidth 1 \\\n\
	-bg [option get . entryBackground Sdr] \\\n\
	 -highlightthickness 0\n\
    if {$yourname!=\"\"} {\n\
	.phone.f.f0.e insert 0 $yourname\n\
    }\n\
    pack .phone.f.f0.e -side left\n\
\n\
    frame .phone.f.f1 \n\
    pack .phone.f.f1 -side top -fill x -expand true\n\
    label .phone.f.f1.l -text \"Email:\"\n\
    pack .phone.f.f1.l -side left -anchor e -fill x -expand true\n\
    entry .phone.f.f1.e -width 40 -relief sunken -borderwidth 1 \\\n\
	-bg [option get . entryBackground Sdr] \\\n\
	 -highlightthickness 0\n\
    if {$youremail!=\"\"} {\n\
	.phone.f.f1.e insert 0 $youremail\n\
    } else {\n\
	.phone.f.f1.e insert 0 \"[getemailaddress]\"\n\
    }\n\
    pack .phone.f.f1.e -side left\n\
\n\
    frame .phone.f.f2 \n\
    pack .phone.f.f2 -side top -fill x -expand true\n\
    label .phone.f.f2.l -text \"Phone:\"\n\
    pack .phone.f.f2.l -side left -anchor e -fill x -expand true\n\
    entry .phone.f.f2.e -width 40 -relief sunken -borderwidth 1 \\\n\
	-bg [option get . entryBackground Sdr] \\\n\
	 -highlightthickness 0\n\
    pack .phone.f.f2.e -side left\n\
\n\
    frame .phone.f.f3 \n\
    pack .phone.f.f3 -side top -fill x -expand true\n\
    button .phone.f.f3.ok -text OK -command {\\\n\
        set yourphone [.phone.f.f2.e get];\\\n\
        set youremail [.phone.f.f1.e get];\\\n\
        set yourname [.phone.f.f0.e get];\\\n\
	if {$yourname=={}} {\\\n\
	    errorpopup \"Please enter your name\" \"Please enter your name\";\\\n\
	    focus .phone.f.f0.e;\\\n\
	    break;\\\n\
	} elseif {$youremail=={}} {\\\n\
	    errorpopup \"Please enter your email address\" \"Please enter your email address\";\\\n\
	    focus .phone.f.f1.e;\\\n\
	    break;\\\n\
	} elseif {$yourphone=={}} {\\\n\
	    errorpopup \"Please enter a phone number\" \"Please enter your telephone number\";\\\n\
	    focus .phone.f.f2.e;\\\n\
	    break;\\\n\
	}\\\n\
        save_prefs; \\\n\
        destroy .phone; \\\n\
        new new}\n\
    pack .phone.f.f3.ok -side left -fill x -expand true\n\
    button .phone.f.f3.cancel -text Cancel -command {destroy .phone}\n\
    pack .phone.f.f3.cancel -side left -fill x -expand true\n\
    move_onscreen .phone\n\
}\n\
\n\
proc configure_rpt_menu {box win} {\n\
    global has_times rpt_menu_value rpt_times duration_max\n\
    global [set win].day\n\
    global [set win].duration\n\
    .new.f2.act.fb$box.m configure -text [lindex $rpt_times $rpt_menu_value($box)]\n\
    if {[lindex $has_times $rpt_menu_value($box)] == 0} {\n\
	foreach i {day.workaround time.workaround duration.workaround} {\n\
	    $win.$i configure -state disabled\n\
	}\n\
	foreach i {l l1 l2 } {\n\
	    $win.$i configure -fg [option get . disabledForeground Sdr]\n\
	}\n\
    } else {\n\
	foreach i {day.workaround time.workaround duration.workaround} {\n\
	    $win.$i configure -state normal\n\
	}\n\
	foreach i {l l1 l2 } {\n\
	    $win.$i configure -fg [option get . foreground Sdr]\n\
	}\n\
	set [set win].duration(duration_max) [lindex $duration_max $rpt_menu_value($box)]\n\
    }\n\
}\n\
\n\
proc configure_duration_box {win no_of_boxes} {\n\
    global rpt_menu_value needs_lifetime rpt_min_values\n\
    set flag 0\n\
    set duration 0\n\
    for {set i 1} {$i<=$no_of_boxes} {incr i} {\n\
	set flag [expr $flag + [lindex $needs_lifetime $rpt_menu_value($i)]]\n\
	if {[lindex $rpt_min_values $rpt_menu_value($i)]> $duration} {\n\
	    set duration [lindex $rpt_min_values $rpt_menu_value($i)]\n\
	}\n\
    }\n\
    if {$flag==0} {\n\
	$win.duration.workaround configure -state disabled\n\
	$win.l configure -foreground [option get . disabledForeground Sdr]\n\
    } else {\n\
	$win.duration.workaround configure -state normal \n\
	$win.duration.workaround set $duration\n\
	$win.duration.workaround minval $duration\n\
	$win.l configure -foreground [option get . foreground Sdr]\n\
   }\n\
}\n\
\n\
proc get_expiry_time {basewin ix durationwin} {\n\
    global rpt_menu_value needs_lifetime has_times\n\
    set dayix [$basewin.day.workaround get]\n\
    set timeofday [$basewin.time.workaround get]\n\
    set duration [expr [$basewin.duration.workaround get]*60]\n\
    set rval $rpt_menu_value($ix)\n\
    set durationmod [expr [lindex $needs_lifetime $rval] * [$durationwin.workaround get] * 60]\n\
    set starttime [expr [lindex $has_times $rval]*[unix_to_ntp [expr $timeofday+($dayix*86400)]]]\n\
    set stoptime [expr [lindex $has_times $rval]*[expr $starttime + $duration + $durationmod]]\n\
    case $rval {\n\
	0 { set rpt_str \"0 0 0\" }\n\
	1 { set rpt_str \"0 $duration 0\"}\n\
	2 { set rpt_str \"86400 $duration 0\"}\n\
	3 { set rpt_str \"604800 $duration 0\"}\n\
	4 { set rpt_str \"1209600 $duration 0\"}\n\
	5 { set rpt_str \"0 0 0\"}\n\
        6 { set rpt_str \"604800 $duration 0 86400 172800 259200 345600\"}\n\
    }\n\
    return \"$starttime $stoptime $rpt_str\"\n\
}\n\
\n\
proc create_menu {mname mlist defattrlist media mode} {\n\
    global media_attr\n\
    if {$mode==\"create\"} {\n\
	menu $mname -tearoff 0\n\
    } else {\n\
	#delete old menus if we're using this to modify a menu\n\
	if {[$mname index end]!=\"none\"} {\n\
	    for {set i 0} {$i <= [$mname index end]} {incr i} {\n\
#		puts \"$i [$mname index end]\"\n\
		catch {destroy [$mname entrycget $i -menu]}\n\
	    }\n\
	    $mname delete 0 end\n\
	}\n\
    }\n\
\n\
    #parse the default attributes for this media/protocol/format\n\
    foreach defattr $defattrlist {\n\
	set tmpattr [lindex [split $defattr \":\"] 0]\n\
	set tmpvalue [lindex [split $defattr \":\"] 1]\n\
	catch {set tmpvalue $media_attr($media,$tmpattr)}\n\
	set media_attr($media,$tmpattr) $tmpvalue\n\
    }\n\
\n\
    #parse the list of attributes this media had last time (empty string if new announcement)\n\
#    foreach attr [array names media_attr] {\n\
#	set tmpmedia [lindex [split $attr ','] 0]\n\
#	set tmpattr [lindex [split $attr ','] 1]\n\
#	if {$tmpmedia==$media} {\n\
#	    if {$tmpattr==\"\"} {\n\
#		set pitem($tmpattr) 1\n\
#	    } else {\n\
#		set pitem($tmpattr) $media_attr($attr)\n\
#	    }\n\
#	}\n\
#    }\n\
\n\
\n\
#    set previtems [split $mediavars ',']\n\
#    foreach previtem $previtems {\n\
#	set pitemlist [split $previtem ':']\n\
#	if {[llength $pitemlist]==1} {\n\
#	    set pitem([lindex $pitemlist 0]) 1\n\
#	} else {\n\
#	    set pitem([lindex $pitemlist 0]) [lindex $pitemlist 1]\n\
#	}\n\
#    }\n\
\n\
    #now create the menus with the above data\n\
#    puts $mlist\n\
    set mitems [split $mlist \"\\n\"]\n\
    foreach item $mitems {\n\
	set itemlist [split $item ':']\n\
	set itemname [lindex $itemlist 0]\n\
        set itemlist [lindex $itemlist 1]\n\
        set code [catch {set media_attr($media,$itemname)}]\n\
	if {$code==1} {set media_attr($media,$itemname) \"\"}\n\
	if {[llength $itemlist]<=1} {\n\
	    $mname add checkbutton -label [get_attr_name $itemname] \\\n\
		-variable media_attr\\($media,$itemname\\) \\\n\
		-command \"mtk_ImbUnpost {}\"\n\
#	    set media_attr($media,$itemname) $pitem($itemname)\n\
	} else {\n\
	    $mname add cascade -label [get_attr_name $itemname] \\\n\
		-menu $mname.$itemname -command \"mtk_ImbUnpost {}\"\n\
	    menu $mname.$itemname -tearoff 0\n\
	    foreach subitem $itemlist {\n\
		$mname.$itemname add radiobutton \\\n\
		    -label [get_attrvalue_name $itemname $subitem] \\\n\
		    -variable media_attr\\($media,$itemname\\) \\\n\
		    -value $subitem -command \"mtk_ImbUnpost {}\"\n\
#		set media_attr($media,$itemname) $pitem($itemname)\n\
	    }\n\
	}\n\
    }\n\
}\n\
proc create_fmt_menu {win mname fmtlist media} {\n\
    menu $mname.menu -tearoff 0\n\
    foreach item $fmtlist {\n\
	$mname.menu add radiobutton -label [get_fmt_name $item] \\\n\
	    -variable media_fmt\\($media\\) \\\n\
	    -value $item \\\n\
	    -command \"reset_media_attrs;\\\n\
                      $mname configure -text \\[get_fmt_name $item\\];\\\n\
                      setmediamode $media $win 1 0\"\n\
    }\n\
}\n\
\n\
proc set_fmt_menu {win mname fmtlist media} {\n\
    global media_fmt\n\
    $mname.menu delete 0 end\n\
    foreach item $fmtlist {\n\
	$mname.menu add radiobutton -label [get_fmt_name $item] \\\n\
	    -variable media_fmt\\($media\\) \\\n\
	    -value $item \\\n\
	    -command \"reset_media_attrs;\\\n\
                      $mname configure -text \\[get_fmt_name $item\\];\\\n\
                      setmediamode $media $win 1 0\"\n\
    }\n\
    set media_fmt($media) [lindex $fmtlist 0]\n\
}\n\
\n\
proc create_proto_menu {win mname fmtmname fmtlist media} {\n\
    menu $mname.menu -tearoff 0\n\
    foreach item $fmtlist {\n\
	$mname.menu add radiobutton -label [get_proto_name $item] \\\n\
	    -variable media_proto\\($media\\) \\\n\
	    -value $item \\\n\
	    -command \"reset_media_attrs;\\\n\
                      $mname configure -text \\[get_proto_name $item\\];\\\n\
                      set_fmt_menu $win $fmtmname \\\n\
                         \\[get_media_fmts $media $item\\] $media;\\\n\
                      setmediamode $media $win 1 0\"\n\
    }\n\
}\n\
\n\
proc reset_media_attrs {} {\n\
    global media_attr\n\
    foreach attr [array names media_attr] {\n\
	unset media_attr($attr)\n\
    }\n\
}\n\
#proc paste_buffer {w} {\n\
#    set ipos [$w index insert]\n\
#    $w insert $ipos [selection get]\n\
#    set str [$w get 1.0 end]\n\
#    $w delete 1.0 end\n\
#    $w insert 1.0 [text_wrap $str 40]\n\
#}\n\
\n\
proc create {} {\n\
    global ttl dayix durationix send zone\n\
    global timeofday minoffset hroffset media_attr media_fmt media_proto\n\
    global medialist new_createtime sess_type\n\
    global rtp_payload sdrversion security\n\
    log \"creating a session\"\n\
    if {$ttl==0} { set ttl [.new.f3.rr.f.e get] }\n\
    if {($ttl < 0)|($ttl > 255)} {\n\
	errorpopup \"Illegal Scope Value\" \"Scope value must be between 0 and 255\"\n\
	log \"user had entered an illegal scope value\"\n\
	return\n\
    }\n\
    set sess \"v=0\"\n\
    set sess \"$sess\\no=[getusername] $new_createtime [unix_to_ntp [gettimeofday]] IN IP4 [gethostaddr]\"\n\
    set sess \"$sess\\ns=[get_new_session_name .new]\"\n\
    if {[get_new_session_name .new]==\"\"} {\n\
	errorpopup \"No Session Name\" \"You must give the session a name\"\n\
	log \"user had entered no session name\"\n\
	return 0\n\
    }\n\
\n\
    if {[get_new_session_desc]==\"\"} {\n\
	errorpopup \"No Session Description\" \"You must give some description of your session\"\n\
	log \"user had entered no session description\"\n\
	return 0\n\
    }\n\
\n\
    set desc [get_new_session_desc]\n\
    regsub -all \"\\n\" $desc \" \" desc\n\
    set sess \"$sess\\ni=$desc\"\n\
    set uri [get_new_session_uri]\n\
    if {$uri!=\"\"} {\n\
	set sess \"$sess\\nu=$uri\"\n\
    }\n\
    set phone [.new.you.f1.e get]\n\
    set email [.new.you.f0.e get]\n\
    if {$phone!=\"\"} {\n\
	set sess \"$sess\\np=$phone\"\n\
    }\n\
    if {$email!=\"\"} {\n\
	set sess \"$sess\\ne=$email\"\n\
    }\n\
\n\
    foreach i {1 2 3} {\n\
      #the catch is here because the simple i/f only has one time entry\n\
      catch {\n\
	set tmp [get_expiry_time .new.f2.act.fb$i $i .new.f2.act.fd.duration]\n\
	    if {[lindex $tmp 0]!=0} {\n\
	    set starttime [lindex $tmp 0]\n\
	    set stoptime [lindex $tmp 1]\n\
	    set sess \"$sess\\nt=[format %u $starttime] [format %u $stoptime]\"\n\
            if {[lindex $tmp 2]!=0} {\n\
		set sess \"$sess\\nr=[lrange $tmp 2 end]\"\n\
	    }\n\
	}\n\
      }\n\
    }\n\
    if {[valid_mcast_address [get_new_session_addr conference]]==0} {\n\
	errorpopup \"Invalid Multicast Address\" \\\n\
	    \"The multicast address specified in not a valid IP Class D address\"\n\
	log \"user had entered an invalid multicast address\"\n\
	return 0\n\
    }\n\
    set sess \"$sess\\na=tool:sdr $sdrversion\"\n\
    set sess \"$sess\\na=type:$sess_type\"\n\
    foreach media $medialist {\n\
	if {$send($media)==1} {\n\
	    if {([get_new_session_port $media]<1024)|([get_new_session_port $media]>65535)} {\n\
		errorpopup \"Bad $media port number\" \\\n\
		    [tt \"Port numbers should be between 1024 and 65535\"]\n\
		log \"user had entered a bad port number\"\n\
		return 0\n\
	    }\n\
	    if {$media_proto($media)==\"rtp\"} {\n\
		set sess \"$sess\\nm=$media [get_new_session_port $media] RTP/AVP $rtp_payload(pt:$media_fmt($media))\"\n\
	    } else {\n\
		set sess \"$sess\\nm=$media [get_new_session_port $media] $media_proto($media) $media_fmt($media)\"\n\
	    }\n\
	    set sess \"$sess\\nc=IN IP4 [get_new_session_addr $media]/$ttl\"\n\
	    foreach attr [array names media_attr] {\n\
		set m [lindex [split $attr \",\"] 0]\n\
		set a [lindex [split $attr \",\"] 1]\n\
		if {$m==$media} {\n\
		    if {$media_attr($attr)==1} {\n\
			set sess \"$sess\\na=$a\"\n\
		    } elseif {($media_attr($attr)!=0)&&\\\n\
			($media_attr($attr)!=\"\")} {\n\
			    set sess \"$sess\\na=$a:$media_attr($attr)\"\n\
			}\n\
		}\n\
	    }\n\
	} \n\
    }\n\
#    puts \"$sess send to $zone(sd_addr,$zone(cur_zone)) $zone(sd_port,$zone(cur_zone)) $ttl\"\n\
    if {[info exists security]&&($security == \"private\")} {\n\
	set keyname [string trim [get_new_session_key] \"\\n\"]\n\
	if {$keyname==0} {return 0};\n\
	log \"new session was encrypted\"\n\
    } else {\n\
	set keyname \"\"\n\
	log \"new session was not encrypted\"\n\
    }\n\
    createsession \"$sess\\n\" [ntp_to_unix $stoptime] $zone(sd_addr,$zone(cur_zone)) $zone(sd_port,$zone(cur_zone)) $ttl $keyname\n\
    update\n\
    after 3000 write_cache\n\
    log \"new session announced at [getreadabletime]\"\n\
    return 1\n\
}\n\
\n\
proc togglemedia {win media} {\n\
    global send\n\
    if {$send($media) == 0} {\n\
        setmediamode $media $win 1 1\n\
    } else {\n\
        setmediamode $media $win 0 1\n\
    }\n\
}\n\
\n\
\n\
#############\n\
#setmediamode is used to set a line of media widgets to active or inactive\n\
#\n\
#$media is typically \"audio\", \"video\", \"whiteboard\" or \"text\"\n\
#$state is 0 (media is inactive) or 1 (media is active)\n\
#$mediabase is the base of the media frame.\n\
#############\n\
proc setmediamode {media mediabase state realloc} {\n\
    global send media_fmt media_proto media_attr zone scope defattrlist\n\
    set base $mediabase.$media\n\
    set send($media) $state\n\
    if {$state==0} {\n\
	$base.cb configure -bitmap cross -foreground red\n\
\n\
	$base.fmt configure -text \" \" -state disabled -relief groove\n\
	#I thought -state disabled would do this but no....\n\
	bind $base.fmt <ButtonRelease> { break }\n\
\n\
	$base.proto configure -text \" \" -state disabled -relief groove\n\
	bind $base.proto <ButtonRelease> { break }\n\
\n\
	$base.addr  delete 0 end\n\
	$base.addr configure -bg [option get . background Sdr] \\\n\
	    -relief groove -state disabled\n\
\n\
	$base.port  delete 0 end\n\
	$base.port configure -bg [option get . background Sdr] \\\n\
	    -relief groove -state disabled\n\
\n\
	$base.mb.workaround configure -relief groove -state disabled\n\
	set media_fmt($media) [lindex [get_media_fmts $media $media_proto($media)] 0]\n\
	set media_proto($media) [lindex [get_media_protos $media] 0]\n\
    } else {\n\
	if {[string compare $media_proto($media) \"\"]==0} {\n\
	    msgpopup \"No tool installed\" \"You have no tool installed that could participate in a session with this media\"\n\
	    set send($media) 0\n\
	    return 0\n\
	}\n\
	$base.cb configure -bitmap tick -foreground green4\n\
\n\
	$base.fmt configure -text [get_fmt_name $media_fmt($media)] -state normal \\\n\
	     -relief raised\n\
	bind $base.fmt <ButtonRelease> \"tkMbButtonUp $base.fmt\"\n\
\n\
	$base.proto configure -text [get_proto_name $media_proto($media)] \\\n\
	    -state normal -relief raised\n\
	bind $base.proto <ButtonRelease> \"tkMbButtonUp $base.proto\"\n\
\n\
	$base.addr configure -bg [option get . entryBackground Sdr] \\\n\
	     -state normal -relief sunken\n\
\n\
	$base.port configure -bg [option get . entryBackground Sdr] \\\n\
	    -relief sunken -state normal\n\
\n\
	if {$realloc==1} {\n\
	    $base.addr delete 0 end\n\
	    if {$scope==\"admin\"} {\n\
		$base.addr insert 0 [generate_address $zone(base_addr,$zone(cur_zone)) $zone(netmask,$zone(cur_zone))]\n\
	    } else {\n\
		$base.addr insert 0 [generate_address]\n\
	    }\n\
	    $base.port delete 0 end\n\
	    $base.port insert 0 [generate_port $media]\n\
	}\n\
\n\
	set attrlist \"[get_proto_attrs $media $media_proto($media)] [get_fmt_attrs $media $media_proto($media) $media_fmt($media)]\"\n\
#	puts $attrlist\n\
	set attrlist [fix_up_attr_list $attrlist]\n\
#	puts \"fmt: $media_fmt($media)\"\n\
	create_menu $base.mb.menu $attrlist $defattrlist($media.$media_proto($media).$media_fmt($media)) $media change\n\
\n\
	$base.mb.workaround configure -relief raised -state normal\n\
    }\n\
}\n\
\n\
proc fix_up_attr_list {origattrlist} {\n\
    #takes an attrlist in the form \"attr1:value attr1:value2 attr2:value3\"\n\
    #and forms an attrlist in the form \"attr1:value1 value2\\nattr2:value3\"\n\
    #this is needed because we merge protocol and format attrs and they\n\
    #may have the same attributes\n\
    set mainattrs {}\n\
    foreach attr $origattrlist {\n\
	set key [lindex [split $attr \":\"] 0]\n\
	set value [lindex [split $attr \":\"] 1]\n\
	if {[lsearch $mainattrs $key]==-1} {\n\
	    set mainattrs \"$mainattrs $key\"\n\
	    set values($key) \\{$value\\}\n\
	} else {\n\
	    if {[lsearch $values($key) $value]==-1} {\n\
		set values($key) \"$values($key) \\{$value\\}\"\n\
	    }\n\
	}\n\
    }\n\
    set newattrlist \"\"\n\
    foreach key $mainattrs {\n\
	if {$newattrlist==\"\"} {\n\
	    set newattrlist $key\n\
	} else {\n\
	    set newattrlist \"$newattrlist\\n$key\"\n\
	}\n\
	if {$values($key)!=\"\"} {\n\
	    set newattrlist \"$newattrlist:$values($key)\"\n\
	}\n\
    }\n\
    return $newattrlist\n\
}\n\
\n\
proc setmediaflags {media win aid} {\n\
    global ldata media_fmt media_proto\n\
    set base $win.$media\n\
    for {set mnum 0} {$mnum<$ldata($aid,medianum)} {incr mnum} {\n\
	if {$ldata($aid,$mnum,media)==$media} {\n\
	    $base.proto configure -text \\\n\
		[get_proto_name $ldata($aid,$mnum,proto)]\n\
	    set media_proto($media) $ldata($aid,$mnum,proto)\n\
	    $base.fmt configure -text [get_fmt_name $ldata($aid,$mnum,fmt)]\n\
	    set media_fmt($media) $ldata($aid,$mnum,fmt)\n\
	    $base.port delete 0 end\n\
	    $base.port insert 0 $ldata($aid,$mnum,port)\n\
	    $base.addr delete 0 end\n\
	    $base.addr insert 0 $ldata($aid,$mnum,addr)\n\
	    return 0\n\
	}\n\
    }\n\
}\n\
\n\
\n\
proc generate_address {args} {\n\
    global zone\n\
    if {[llength $args]==0} {\n\
	return [ui_generate_address]\n\
    } elseif {[llength $args]==2} {\n\
	return [eval \"ui_generate_address $args\"]\n\
    } elseif {([llength $args]==3)||([llength $args]==1)} {\n\
	if {([llength $args]==3)} {\n\
	    set baseaddr [lindex $args 0]\n\
	    set netmask [lindex $args 1]\n\
	    set aid [lindex $args 2]\n\
	} else {\n\
	    set z $zone(ttl_scope)\n\
	    set baseaddr $zone(base_addr,$z)\n\
	    set netmask $zone(netmask,$z)\n\
	    set aid [lindex $args 0]\n\
	}\n\
	if {[string compare $aid \"new\"]==0} {\n\
	    return [ui_generate_address $baseaddr $netmask]\n\
	} else {\n\
	    #we check if we really need to generate a new address or\n\
	    #if the old one is still OK...\n\
	    global ldata\n\
	    set pa [split $ldata($aid,tmpmulticast) \".\"]\n\
	    #it's simpler to subtract 224 from the msb than fix Tcl's \n\
	    #concept of what's positive and what's negative...\n\
	    set paddr [expr ((((((([lindex $pa 0]-224)*256)\\\n\
				 +[lindex $pa 1])*256)\\\n\
				     +[lindex $pa 2])*256)\\\n\
				     +[lindex $pa 3])]\n\
	    set ba [split $baseaddr \".\"]\n\
	    set baddr [expr ((((((([lindex $ba 0]-224)*256)\\\n\
				 +[lindex $ba 1])*256)\\\n\
				     +[lindex $ba 2])*256)\\\n\
				     +[lindex $ba 3])]\n\
	    set paddr [expr $paddr >> (32-$netmask)]\n\
	    set baddr [expr $baddr >> (32-$netmask)]\n\
	    if {$paddr==$baddr} {\n\
		#we don't really need to generate a new address in \n\
		#these circumstances, so don't do so (avoid confusion).\n\
		return 1\n\
	    } else {\n\
		#should really warn the user when we have to do this\n\
		toplevel .warn\n\
		wm title .warn \"Sdr: [tt \"Warning\"]\"\n\
		frame .warn.f -borderwidth 2 -relief groove\n\
		pack .warn.f -side top -fill both\n\
		message .warn.f.msg -aspect 400 -text \\\n\
		    [tt \"To make this scope change I need to allocate new multicast addresses.\\n\\nThis means that anyone who is already using this annoucement will need to restart their applications\\n\\nIs this OK?\"]\n\
		pack .warn.f.msg -side top -fill x -expand true\n\
		frame .warn.f.f -borderwidth 0\n\
		pack .warn.f.f -side top -fill x -expand true\n\
		button .warn.f.ok -text [tt \"OK\"] -command \\\n\
		    \"set ldata($aid,tmpmulticast2) \\\n\
                    \\[ui_generate_address $baseaddr $netmask\\];\\\n\
                    destroy .warn\"\n\
		pack .warn.f.ok -side left -fill x -expand true\n\
		button .warn.f.cancel -text [tt \"Cancel\"] -command \\\n\
		    \"set ldata($aid,tmpmulticast2) 0;\n\
		    destroy .warn\"\n\
		pack .warn.f.cancel -side left -fill x -expand true\n\
		tkwait visibility .warn\n\
		grab set .warn\n\
		tkwait window .warn\n\
		if {$ldata($aid,tmpmulticast2)==0} {\n\
		    unset ldata($aid,tmpmulticast2)\n\
		    return 0\n\
		} else {\n\
		    set ldata($aid,tmpmulticast) $ldata($aid,tmpmulticast2)\n\
		    unset ldata($aid,tmpmulticast2)\n\
		    return $ldata($aid,tmpmulticast)\n\
		}\n\
	    }\n\
	}\n\
    }\n\
}\n\
\n\
proc generate_port {media} {\n\
    ui_generate_port $media\n\
}\n\
";
